import { MathOperator, MathOpSymbol } from "../helpers/operators";
import { KeyValueSuggestion, KeyValueTextDisplay } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
import { NumberDelimiters } from "../helpers/formatting";
import NumberFormat = Intl.NumberFormat;
export interface SlackNumberModifierKeyValue {
    operator: MathOpSymbol | MathOperator;
    number: number;
}
export interface NumberModifierKeyValue extends SlackNumberModifierKeyValue {
    operator: MathOperator;
}
export declare type RoundMode = "not" | "up" | "down" | "math";
export default class NumberModifierKeyValueType extends KeyValueType<NumberModifierKeyValue> {
    static apply(value: NumberModifierKeyValue, number: number, roundMode?: RoundMode): number;
    private _delimiters;
    private _groupsDelimiterRegex;
    set delimiters(delimiters: NumberDelimiters);
    private _numberFormatter?;
    set numberFormatter(numberFormatter: NumberFormat | undefined);
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): NumberModifierKeyValue | undefined;
    checkValue(val: any): NumberModifierKeyValue | undefined;
    display(value: SlackNumberModifierKeyValue): KeyValueTextDisplay;
    editText(value: SlackNumberModifierKeyValue): string;
    isValueEqual(valueA?: NumberModifierKeyValue, valueB?: NumberModifierKeyValue): boolean;
}
