import { KeyValueDisplay, KeyValueSuggestion } from "./KeyValueDatatypes";
import { KeyValueType } from "./KeyValueType";
export interface RegexKeyValue {
    text: string;
    printRegex?: string;
    regex: string;
    options: string;
}
export default class RegexKeyValueType extends KeyValueType<RegexKeyValue> {
    static mongoSelectorFor(value: RegexKeyValue): {
        $regex: string;
        $options: string;
    };
    getSuggestions(prefix: string): KeyValueSuggestion[];
    parseString(val: string): RegexKeyValue | undefined;
    checkValue(val: any): RegexKeyValue | undefined;
    display(value: RegexKeyValue): KeyValueDisplay;
    editText(value: RegexKeyValue): string;
    isValueEqual(valueA?: RegexKeyValue, valueB?: RegexKeyValue): boolean;
}
